Package ghidra.app.util.bin.format.pe.resource

# Class ResourceDirectoryStringU

java.lang.Object
ghidra.app.util.bin.format.pe.resource.ResourceDirectoryStringU

All Implemented Interfaces:
  `StructConverter`

public class ResourceDirectoryStringU extends Object implements StructConverter

     typedef struct _IMAGE_RESOURCE_DIR_STRING_U {
         WORD    Length;
         WCHAR   NameString[ 1 ];
     };

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `NAME`

  ### Fields inherited from interface ghidra.app.util.bin.StructConverter

  `ASCII, BYTE, DWORD, IBO32, IBO64, POINTER, QWORD, SLEB128, STRING, ULEB128, UTF16, UTF8, VOID, WORD`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ResourceDirectoryStringU(BinaryReader reader, int index)`
  Constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `short`
  `getLength()`
  Returns the length of the string, in bytes.
  `String`
  `getNameString()`
  Returns the resource name string.
  `DataType`
  `toDataType()`
  Returns a structure datatype representing the contents of the implementor of this interface.
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### NAME

    public static final String NAME
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### ResourceDirectoryStringU

    public ResourceDirectoryStringU(BinaryReader reader, int index) throws IOException
    Constructor.
    Parameters:
      `reader` - the binary reader
      `index` - the index where this resource string begins
    Throws:
      `IOException`

- ## Method Details

  - ### getLength

    public short getLength()
    Returns the length of the string, in bytes.
    Returns:
      the length of the string, in bytes

  - ### getNameString

    public String getNameString()
    Returns the resource name string.
    Returns:
      the resource name string

  - ### toDataType

    public DataType toDataType() throws DuplicateNameException, IOException
    Description copied from interface: `StructConverter`
    Returns a structure datatype representing the contents of the implementor of this interface.

    For example, given:

         class A {
             int foo;
             double bar;
         }

    The return value should be a structure data type with two data type components; an INT and a DOUBLE. The structure should contain field names and, if possible, field comments.

    Specified by:
      `toDataType` in interface `StructConverter`
    Returns:
      returns a structure datatype representing the implementor of this interface
    Throws:
      `DuplicateNameException` - when a datatype of the same name already exists
      `IOException` - if an IO-related error occurs
    See Also:
      - `StructureDataType`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`